Index: my-react-app/src/components/RestaurantDetails.js
===================================================================
--- my-react-app/src/components/RestaurantDetails.js	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ my-react-app/src/components/RestaurantDetails.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -5,18 +5,15 @@
 import { useParams } from 'react-router-dom';
 import StarRating from "./StarRating";
-import MenuList from "./MenuList";
-
 
 const RestaurantDetails = () => {
     const navigate = useNavigate();
+
     const { id } = useParams();
-    const [preOrderedItems, setPreOrderedItems] = useState([]);
-
     const [restaurant, setRestaurant] = useState(null);
     const [selectedTableId, setSelectedTableId] = useState('');
-    const [selectedDate, setSelectedDate] = useState('');
-    const [selectedTime, setSelectedTime] = useState('');
-    const [timeOptions, setTimeOptions] = useState([]);
+    const [selectedTimeSlot, setSelectedTimeSlot] = useState('');
     const [selectedTable, setSelectedTable] = useState(null);
+    const [filteredTimeSlots, setFilteredTimeSlots] = useState([]);
+    const [selectedCapacity, setSelectedCapacity] = useState(''); // Define selectedCapacity state
 
     useEffect(() => {
@@ -24,5 +21,5 @@
             try {
                 if (!id) return;
-                const response = await axios.get(`http://localhost:8081/api/restaurants/${id}`);
+                const response = await axios.get(`http://localhost:8080/api/restaurants/${id}`);
                 setRestaurant(response.data);
             } catch (error) {
@@ -35,9 +32,9 @@
 
     useEffect(() => {
-        if (!selectedTableId) return;
+        if (!selectedTableId) return; // If no table is selected, return early
 
         const fetchTableDetails = async () => {
             try {
-                const response = await axios.get(`http://localhost:8081/api/tables/${selectedTableId}`);
+                const response = await axios.get(`http://localhost:8080/api/tables/${selectedTableId}`);
                 setSelectedTable(response.data);
             } catch (error) {
@@ -49,76 +46,43 @@
     }, [selectedTableId]);
 
-    const today = new Date();
-    const year = today.getFullYear();
-    const month = String(today.getMonth() + 1).padStart(2, '0');
-    const day = String(today.getDate()).padStart(2, '0');
-    const formattedDate = `${year}-${month}-${day}`;
-    const parseOperatingHours = (operatingHours) => {
-        const [start, end] = operatingHours.split('-');
-        const [startHour, startMinute] = start.split(':').map(Number);
-        const [endHour, endMinute] = end.split(':').map(Number);
+    useEffect(() => {
+        if (!selectedTable || !restaurant) return; // If table or restaurant is not loaded, return early
 
-        const startTime = new Date();
-        startTime.setHours(startHour, startMinute, 0, 0);
+        // Filter time slots based on the selected table
+        const currentTime = new Date();
+        const filteredSlots = selectedTable.timeSlots.filter(timeSlot => new Date(timeSlot) >= currentTime);
+        setFilteredTimeSlots(filteredSlots);
+    }, [selectedTable, restaurant]);
 
-        const endTime = new Date();
-        endTime.setHours(endHour < startHour ? endHour + 24 : endHour, endMinute, 0, 0);
 
-        return { startTime, endTime };
+    const formatTimeSlot = (timeSlot) => {
+        const date = new Date(timeSlot);
+        const formattedDate = date.toLocaleDateString();
+        const formattedTime = date.toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' });
+        return `${formattedDate} - ${formattedTime}`;
     };
 
-    const generateTimeOptions = (operatingHours) => {
-        const { startTime, endTime } = parseOperatingHours(operatingHours);
-        const now = new Date();
-
-        const selectedDateObj = new Date(selectedDate);
-        const isToday = selectedDateObj.toDateString() === now.toDateString();
-
-        let currentTime = isToday ? roundToNext15Minutes(new Date()) : new Date(startTime);
-
-        const options = [];
-        while (currentTime <= endTime) {
-            options.push(currentTime.toTimeString().slice(0, 5));
-            currentTime = new Date(currentTime.getTime() + 15 * 60 * 1000);
-        }
-
-        return options;
+    const handleTableSelect = (event) => {
+        const selectedTableId = event.target.value;
+        setSelectedTableId(selectedTableId);
     };
 
-    useEffect(() => {
-        if (restaurant && selectedDate) {
-            const options = generateTimeOptions(restaurant.operatingHours);
-            setTimeOptions(options);
-        }
-    }, [restaurant, selectedDate]);
-
-    const handleTableSelect = (event) => {
-        setSelectedTableId(event.target.value);
+    const handleTimeSlotSelect = (event) => {
+        const selectedTimeSlot = event.target.value;
+        setSelectedTimeSlot(selectedTimeSlot);
     };
 
-    const handleReservationConfirmation = () => {
-        const encodedTableId = encodeURIComponent(selectedTableId);
-        const encodedDateTime = encodeURIComponent(`${selectedDate}T${selectedTime}`);
-        const encodedRestaurantId = encodeURIComponent(restaurant.restaurantId);
+    const handleReservationConfirmation = (restaurant) => {
+        const tableNumber = selectedTableId;
+        const formattedTimeSlot = selectedTimeSlot;
+        const restaurantId = restaurant.restaurantId;
 
-        const totalPrice = preOrderedItems.reduce((acc, item) => acc + item.price * item.quantity, 0).toFixed(2);
+        const encodedTableNumber = encodeURIComponent(tableNumber);
+        const encodedTimeSlot = encodeURIComponent(formattedTimeSlot);
+        const encodedRestaurantId = encodeURIComponent(restaurantId);
 
-        navigate(`/reservationConfirmation/${encodedTableId}/${encodedDateTime}/${encodedRestaurantId}`, {
-            state: {
-                preOrderedItems: preOrderedItems,
-                totalPrice: totalPrice,
-            }
-        });
+        navigate(`/reservationConfirmation/${encodedTableNumber}/${encodedTimeSlot}/${encodedRestaurantId}`);
     };
 
-    const roundToNext15Minutes = (date) => {
-        const minutes = date.getMinutes();
-        const remainder = minutes % 15;
-        if (remainder === 0) return date;
-
-        date.setMinutes(minutes + 15 - remainder);
-        date.setSeconds(0, 0);
-        return date;
-    };
 
     return (
@@ -127,5 +91,5 @@
                 <>
                     <h2 className="card-title">
-                        {restaurant.name} <StarRating key={restaurant.id} rating={restaurant.rating} />
+                        {restaurant.name} <StarRating key={restaurant.id} rating={restaurant.rating}/>
                     </h2>
                     <div className="restaurant-details">
@@ -134,63 +98,30 @@
                         <p>Address: {restaurant.address}</p>
                         <p>Phone: {restaurant.phone}</p>
-                        <p>
-                            Website: <a href={restaurant.website}>{restaurant.website}</a>
-                        </p>
+                        <p>Website: <a href={restaurant.website}>{restaurant.website}</a></p>
                         <p>Social Media Links: {restaurant.socialMediaLinks}</p>
 
                         <label>Select Table:</label>
-                        <select
-                            className="form-select"
-                            aria-label="Select Table"
-                            onChange={handleTableSelect}
-                            value={selectedTableId}
-                        >
+                        <select className="form-select" aria-label="Select Table" onChange={handleTableSelect}
+                                value={selectedTableId}>
                             <option value="">Select Table</option>
-                            {restaurant.tablesList.map((table) => (
-                                <option key={table.id} value={table.id}>
-                                    {`Capacity: ${table.capacity} - ${table.location}`}
-                                </option>
+                            {restaurant.tablesList.map((table, index) => (
+                                <option key={index}
+                                        value={table.id}>{`Capacity: ${table.capacity} - ${table.location}`}</option>
                             ))}
                         </select>
-
                         {selectedTable && (
                             <>
-                                <label>Select Date:</label>
-                                <input
-                                    type="date"
-                                    className="form-control mt-2"
-                                    onChange={(event) => setSelectedDate(event.target.value)}
-                                    value={selectedDate}
-                                    min={formattedDate}
-                                    onKeyDown={(e) => e.preventDefault()}
-                                />
-                                {!selectedDate && <p style={{ color: "red" }}>Please select a valid date.</p>}
-
-                                <label>Select Time:</label>
-                                <select
-                                    className="form-select mt-2"
-                                    onChange={(event) => setSelectedTime(event.target.value)}
-                                    value={selectedTime}
-                                    disabled={!selectedDate}
-                                >
-                                    <option value="">Select Time</option>
-                                    {timeOptions.map((time, index) => (
-                                        <option key={index} value={time}>
-                                            {time}
-                                        </option>
+                                <label>Select Time Slot:</label>
+                                <select className="form-select mt-2" aria-label="Select Time Slot" onChange={handleTimeSlotSelect}>
+                                    <option value="">Select Time Slot</option>
+                                    {filteredTimeSlots.map((timeSlot, index) => (
+                                        <option key={index} value={timeSlot}>{formatTimeSlot(timeSlot)}</option>
                                     ))}
                                 </select>
                             </>
                         )}
-                        <MenuList
-                            restaurantId={restaurant.restaurantId}
-                            setPreOrderedItems={setPreOrderedItems}
-                            preOrderedItems={preOrderedItems}
-                        />
-                        <br />
-                        <button
-                            className="btn btn-primary"
-                            onClick={handleReservationConfirmation}
-                            disabled={!selectedTableId || !selectedDate || !selectedTime}>
+                        <br/>
+                        {/* Add a button to trigger reservation confirmation */}
+                        <button className="btn btn-primary" onClick={() => handleReservationConfirmation(restaurant)}>
                             Confirm Reservation
                         </button>
Index: my-react-app/src/components/RestaurantInfo.js
===================================================================
--- my-react-app/src/components/RestaurantInfo.js	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ my-react-app/src/components/RestaurantInfo.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -1,5 +1,4 @@
 import React from 'react';
 import StarRating from "./StarRating";
-import MenuList from "./MenuList";
 
 const RestaurantInfo = ({ restaurant }) => {
@@ -9,8 +8,7 @@
                 {restaurant.name} <StarRating key={restaurant.id} rating={restaurant.rating}/>
             </h2>
-            <p className="card-text">{restaurant.cuisineType}</p>
-            <p className="card-text">{restaurant.operatingHours}</p>
-            <p className="card-text">Ul. {restaurant.address}</p>
-            <MenuList restaurantId={restaurant.id} />
+            <p className="card-text">{restaurant.cuisineType}</p> {/* Assuming cuisineType is provided */}
+            <p className="card-text">{restaurant.operatingHours}</p> {/* Assuming operatingHours is provided */}
+            <p className="card-text">Ul. {restaurant.address}</p> {/* Assuming address is provided */}
         </div>
     );
Index: my-react-app/src/components/Restaurants.js
===================================================================
--- my-react-app/src/components/Restaurants.js	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ my-react-app/src/components/Restaurants.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -1,61 +1,28 @@
-import React, {useState, useEffect, useContext} from 'react';
+import React, { useState, useEffect } from 'react';
+import axios from 'axios';
 import 'bootstrap/dist/css/bootstrap.min.css';
 import StarRating from './StarRating';
 import { useNavigate } from 'react-router-dom';
-import {RestaurantContext} from "./RestaurantContext";
-import {Alert} from "bootstrap";
-
-const parseTime = (timeString) => {
-    const [hours, minutes] = timeString.trim().split(':').map(Number);
-    return new Date().setHours(hours, minutes, 0, 0);
-};
-
-const roundToNextQuarter = (date) => {
-    const minutes = date.getMinutes();
-    const roundedMinutes = Math.floor(minutes / 15) * 15;
-    date.setMinutes(roundedMinutes, 0, 0);
-    return date;
-};
-
-const shouldMoveToNextDay = (currentTime, endTime) => {
-    return (endTime - currentTime) <= 2 * 60 * 60 * 1000;
-};
 
 const Restaurants = () => {
     const [restaurants, setRestaurants] = useState([]);
     const navigate = useNavigate();
-    const restaurantContext = useContext(RestaurantContext);
 
     useEffect(() => {
-        setRestaurants(restaurantContext.restaurants);
-    }, [restaurantContext]);
+        const fetchRestaurants = async () => {
+            try {
+                const response = await axios.get('http://localhost:8080/api/restaurants');
+                setRestaurants(response.data);
+            } catch (error) {
+                console.error('Error fetching restaurants:', error);
+            }
+        };
 
-
-    const generateTimeSlots = (operatingHours) => {
-        const timeSlots = [];
-        const [startTimeStr, endTimeStr] = operatingHours.split('-').map((time) => time.trim());
-
-        const startTime = parseTime(startTimeStr);
-        let endTime = parseTime(endTimeStr);
-
-        const currentTime = new Date().getTime();
-        if (shouldMoveToNextDay(currentTime, endTime)) {
-            endTime += 24 * 60 * 60 * 1000;
-        }
-
-        let currentTimeSlot = new Date(startTime);
-        currentTimeSlot = roundToNextQuarter(currentTimeSlot);
-
-        while (currentTimeSlot.getTime() < endTime) {
-            timeSlots.push(currentTimeSlot.toISOString());
-            currentTimeSlot.setMinutes(currentTimeSlot.getMinutes() + 15);
-        }
-
-        return timeSlots;
-    };
+        fetchRestaurants();
+    }, []);
 
     const handleDetailClick = (restaurantId) => {
         navigate(`/restaurants/${restaurantId}`);
-    };
+    }
 
     const handleTimeSlotClick = (table, timeSlot, restaurant) => {
@@ -64,49 +31,40 @@
         const restaurantId = restaurant.restaurantId;
 
-        const encodedTableNumber = encodeURIComponent(tableNumber);
+        const encodedTableNumber = encodeURI(tableNumber);
         const encodedTimeSlot = encodeURIComponent(formattedTimeSlot);
         const encodedRestaurantId = encodeURIComponent(restaurantId);
 
         navigate(`/reservationConfirmation/${encodedTableNumber}/${encodedTimeSlot}/${encodedRestaurantId}`);
-    };
+    }
 
     const renderTimeSlots = (tablesList, restaurant) => {
         const currentTime = new Date().getTime();
-        let renderedTimeSlots = {};
+        let renderedTimeSlots = {}; // Object to store rendered slots for each table capacity
 
-        if (tablesList.length === 0) {
-            return <p>No tables available for reservations at this restaurant.</p>;
-        }
-
-        return tablesList.flatMap((table) => {
-            const tableTimeSlots = generateTimeSlots(restaurant.operatingHours);
-
+        return tablesList.flatMap(table => {
+            // Render capacity header when encountering a new capacity
             if (!renderedTimeSlots[table.capacity]) {
                 renderedTimeSlots[table.capacity] = 0;
                 return (
                     <div key={table.capacity}>
-                        <h3>Table for {table.capacity} guests</h3>
-                        {tableTimeSlots.map((timeSlot, index) => {
+                        <h3>Table for: {table.capacity}</h3>
+                        {table.timeSlots.map((timeSlot, index) => {
                             const timeSlotTime = new Date(timeSlot).getTime();
+                            const tableCapacity = table.capacity;
 
-                            if (timeSlotTime > currentTime && renderedTimeSlots[table.capacity] < 3) {
-                                renderedTimeSlots[table.capacity]++;
+                            // Check if the time slot is after the current time and limit to 3 slots
+                            if (timeSlotTime > currentTime && renderedTimeSlots[tableCapacity] < 3) {
+                                renderedTimeSlots[tableCapacity]++;
                                 const timeSlotDateTime = new Date(timeSlot);
-                                const formattedTime = timeSlotDateTime.toLocaleTimeString([], {
-                                    hour: '2-digit',
-                                    minute: '2-digit'
-                                });
+                                const formattedTime = timeSlotDateTime.toLocaleTimeString();
+                                const formattedDateTime = timeSlotDateTime.toLocaleString(); // Format for both date and time
 
                                 return (
-                                    <button
-                                        key={index}
-                                        className="btn btn-primary me-2 mb-2"
-                                        onClick={() => handleTimeSlotClick(table, timeSlot, restaurant)}
-                                    >
-                                        {formattedTime} {}
+                                    <button key={index} className="btn btn-primary me-2 mb-2" onClick={() => handleTimeSlotClick(table, timeSlot, restaurant)}>
+                                        {formattedDateTime} {/* Display both date and time */}
                                     </button>
                                 );
                             } else {
-                                return null;
+                                return null; // Render nothing if the condition is not met
                             }
                         })}
@@ -114,8 +72,11 @@
                 );
             } else {
+                // If capacity has been rendered, return null to avoid duplicate rendering
                 return null;
             }
         });
-    };
+
+    }
+
 
     return (
@@ -124,25 +85,18 @@
             <div className="row">
                 {restaurants.map((restaurant) => (
-                    <div key={restaurant.restaurantId} className="col-md-4 mb-4">
+                    <div key={restaurant.id} className="col-md-4 mb-4">
                         <div className="card">
                             <div className="card-body">
                                 <h5 className="card-title">
-                                    {restaurant.name}
+                                    {restaurant.name} <StarRating key={restaurant.id} rating={restaurant.rating}/>
                                 </h5>
                                 <p className="card-text">{restaurant.cuisineType}</p>
                                 <p className="card-text">{restaurant.operatingHours}</p>
                                 <p className="card-text">Ul. {restaurant.address}</p>
-
-                                {restaurant.tablesList && restaurant.tablesList.length > 0 ? (
-                                    <div className="d-flex flex-wrap">
-                                        {renderTimeSlots(restaurant.tablesList, restaurant)}
-                                    </div>
-                                ) : (
-                                    <p>No tables available for reservations at this restaurant.</p>
-                                )}
+                                <div className="d-flex flex-wrap">
+                                    {renderTimeSlots(restaurant.tablesList.flatMap((table) => table), restaurant)}
+                                </div>
                             </div>
-                            <button onClick={() => handleDetailClick(restaurant.restaurantId)} className="btn btn-primary">
-                                View Details
-                            </button>
+                            <button onClick={() => handleDetailClick(restaurant.restaurantId)} className="btn btn-primary">View Details</button>
                         </div>
                     </div>
Index: my-react-app/src/components/StarRating.js
===================================================================
--- my-react-app/src/components/StarRating.js	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ my-react-app/src/components/StarRating.js	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -2,6 +2,9 @@
 
 const StarRating = ({ rating }) => {
+    // Convert the rating to a number between 0 and 5
     const normalizedRating = Math.min(Math.max(0, rating), 5);
+    // Calculate the number of filled stars
     const filledStars = Math.floor(normalizedRating);
+    // Calculate the number of half stars
     const hasHalfStar = normalizedRating - filledStars >= 0.5;
 
@@ -9,11 +12,9 @@
         <div>
             {[...Array(filledStars)].map((_, index) => (
-                <span key={`filled-${index}`} className="star">&#9733;</span>
+                <span key={index} className="star">&#9733;</span>
             ))}
-
-            {hasHalfStar && <span className="star half">&#9733;</span>}
-
+            {hasHalfStar && <span className="star">&#9734;</span>}
             {[...Array(5 - filledStars - (hasHalfStar ? 1 : 0))].map((_, index) => (
-                <span key={`empty-${index}`} className="star">&#9734;</span>
+                <span key={filledStars + index + 1} className="star">&#9734;</span>
             ))}
         </div>
@@ -22,3 +23,2 @@
 
 export default StarRating;
-
